library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity de2_led_flasher is
  
  port (
    clk        : in  std_logic;
    reset_n    : in  std_logic;
    inp		   : in  std_logic_vector(15 downto 0);
	 di		  	: in  std_logic_vector(15 downto 0);
    address    : out std_logic_vector(17 downto 0);

    do     	  	: out std_logic_vector(15 downto 0)
    );
  
end de2_led_flasher;

architecture rtl of de2_led_flasher is

  signal counter : unsigned(22 downto 0);
  signal display_address : std_logic_vector(17 downto 0);

begin
  process (clk)
  begin
    if rising_edge(clk) then
      if reset_n = '0' then
        address <= (others => '0');
      else
          if counter = 0 then
            counter <= (others => '1'); 
				address <= display_address;
				display_address <= std_logic_vector( unsigned(display_address) + 1);
				if display_address = "000000001111111111" then
					display_address <= "000000000000000000";
				end if;
				do <= di;
          else
            counter <= counter - 1;
          end if;
      end if;
    end if;
  end process;

end rtl;
